diff --git a/libpurple/purpleperson.c b/libpurple/purpleperson.c
--- a/libpurple/purpleperson.c
+++ b/libpurple/purpleperson.c
@@ -36,7 +36,7 @@
 	PROP_ALIAS,
 	PROP_AVATAR,
 	PROP_TAGS,
-	PROP_PRIORITY_CONTACT,
+	PROP_PRIORITY_CONTACT_INFO,
 	N_PROPERTIES
 };
 static GParamSpec *properties[N_PROPERTIES] = {NULL, };
@@ -61,33 +61,33 @@
 
 static gint
 purple_person_contact_compare(gconstpointer a, gconstpointer b) {
-	PurpleContact *c1 = *(PurpleContact **)a;
-	PurpleContact *c2 = *(PurpleContact **)b;
+	PurpleContactInfo *c1 = *(PurpleContactInfo **)a;
+	PurpleContactInfo *c2 = *(PurpleContactInfo **)b;
 	PurplePresence *p1 = NULL;
 	PurplePresence *p2 = NULL;
 
-	p1 = purple_contact_get_presence(c1);
-	p2 = purple_contact_get_presence(c2);
+	p1 = purple_contact_info_get_presence(c1);
+	p2 = purple_contact_info_get_presence(c2);
 
 	return purple_presence_compare(p1, p2);
 }
 
 static void
 purple_person_sort_contacts(PurplePerson *person) {
-	PurpleContact *original_priority = NULL;
-	PurpleContact *new_priority = NULL;
+	PurpleContactInfo *original_priority = NULL;
+	PurpleContactInfo *new_priority = NULL;
 	guint n_items = person->contacts->len;
 
 	if(n_items <= 1) {
 		g_object_notify_by_pspec(G_OBJECT(person),
-		                         properties[PROP_PRIORITY_CONTACT]);
+		                         properties[PROP_PRIORITY_CONTACT_INFO]);
 
 		g_list_model_items_changed(G_LIST_MODEL(person), 0, n_items, n_items);
 
 		return;
 	}
 
-	original_priority = purple_person_get_priority_contact(person);
+	original_priority = purple_person_get_priority_contact_info(person);
 
 	g_ptr_array_sort(person->contacts, purple_person_contact_compare);
 
@@ -98,7 +98,7 @@
 	new_priority = g_ptr_array_index(person->contacts, 0);
 	if(original_priority != new_priority) {
 		g_object_notify_by_pspec(G_OBJECT(person),
-		                         properties[PROP_PRIORITY_CONTACT]);
+		                         properties[PROP_PRIORITY_CONTACT_INFO]);
 	}
 }
 
@@ -118,7 +118,7 @@
  *****************************************************************************/
 static GType
 purple_person_get_item_type(G_GNUC_UNUSED GListModel *list) {
-	return PURPLE_TYPE_CONTACT;
+	return PURPLE_TYPE_CONTACT_INFO;
 }
 
 static guint
@@ -131,7 +131,7 @@
 static gpointer
 purple_person_get_item(GListModel *list, guint position) {
 	PurplePerson *person = PURPLE_PERSON(list);
-	PurpleContact *contact = NULL;
+	PurpleContactInfo *contact = NULL;
 
 	if(position < person->contacts->len) {
 		contact = g_ptr_array_index(person->contacts, position);
@@ -174,9 +174,9 @@
 		case PROP_TAGS:
 			g_value_set_object(value, purple_person_get_tags(person));
 			break;
-		case PROP_PRIORITY_CONTACT:
+		case PROP_PRIORITY_CONTACT_INFO:
 			g_value_set_object(value,
-			                   purple_person_get_priority_contact(person));
+			                   purple_person_get_priority_contact_info(person));
 			break;
 		default:
 			G_OBJECT_WARN_INVALID_PROPERTY_ID(obj, param_id, pspec);
@@ -322,10 +322,10 @@
 	 *
 	 * Since: 3.0.0
 	 */
-	properties[PROP_PRIORITY_CONTACT] = g_param_spec_object(
+	properties[PROP_PRIORITY_CONTACT_INFO] = g_param_spec_object(
 		"priority-contact", "priority-contact",
 		"The priority contact for the person",
-		PURPLE_TYPE_CONTACT,
+		PURPLE_TYPE_CONTACT_INFO,
 		G_PARAM_READABLE | G_PARAM_STATIC_STRINGS);
 
 	g_object_class_install_properties(obj_class, N_PROPERTIES, properties);
@@ -387,30 +387,34 @@
 }
 
 void
-purple_person_add_contact(PurplePerson *person, PurpleContact *contact) {
+purple_person_add_contact_info(PurplePerson *person,
+                               PurpleContactInfo *contact)
+{
 	PurplePresence *presence = NULL;
 
 	g_return_if_fail(PURPLE_IS_PERSON(person));
-	g_return_if_fail(PURPLE_IS_CONTACT(contact));
+	g_return_if_fail(PURPLE_IS_CONTACT_INFO(contact));
 
 	g_ptr_array_add(person->contacts, g_object_ref(contact));
 
-	presence = purple_contact_get_presence(contact);
+	presence = purple_contact_info_get_presence(contact);
 	g_signal_connect_object(presence, "notify",
 	                        G_CALLBACK(purple_person_presence_notify_cb),
 	                        person, 0);
 
-	purple_contact_set_person(contact, person);
+	purple_contact_info_set_person(contact, person);
 
 	purple_person_sort_contacts(person);
 }
 
 gboolean
-purple_person_remove_contact(PurplePerson *person, PurpleContact *contact) {
+purple_person_remove_contact_info(PurplePerson *person,
+                                  PurpleContactInfo *contact)
+{
 	gboolean removed = FALSE;
 
 	g_return_val_if_fail(PURPLE_IS_PERSON(person), FALSE);
-	g_return_val_if_fail(PURPLE_IS_CONTACT(contact), FALSE);
+	g_return_val_if_fail(PURPLE_IS_CONTACT_INFO(contact), FALSE);
 
 	/* Ref the contact to avoid a use-after free. */
 	g_object_ref(contact);
@@ -421,13 +425,13 @@
 	removed = g_ptr_array_remove(person->contacts, contact);
 
 	if(removed) {
-		PurplePresence *presence = purple_contact_get_presence(contact);
+		PurplePresence *presence = purple_contact_info_get_presence(contact);
 
 		g_signal_handlers_disconnect_by_func(presence,
 		                                     purple_person_presence_notify_cb,
 		                                     person);
 
-		purple_contact_set_person(contact, NULL);
+		purple_contact_info_set_person(contact, NULL);
 
 		purple_person_sort_contacts(person);
 	}
@@ -438,8 +442,8 @@
 	return removed;
 }
 
-PurpleContact *
-purple_person_get_priority_contact(PurplePerson *person) {
+PurpleContactInfo *
+purple_person_get_priority_contact_info(PurplePerson *person) {
 	g_return_val_if_fail(PURPLE_IS_PERSON(person), NULL);
 
 	if(person->contacts->len == 0) {
diff --git a/libpurple/tests/meson.build b/libpurple/tests/meson.build
--- a/libpurple/tests/meson.build
+++ b/libpurple/tests/meson.build
@@ -4,6 +4,7 @@
     'authorization_request',
     'circular_buffer',
     'contact',
+    'contact_info',
     'contact_manager',
     'credential_manager',
     'credential_provider',
diff --git a/libpurple/tests/test_contact.c b/libpurple/tests/test_contact.c
--- a/libpurple/tests/test_contact.c
+++ b/libpurple/tests/test_contact.c
@@ -29,12 +29,14 @@
 test_purple_contact_new(void) {
 	PurpleAccount *account = NULL;
 	PurpleContact *contact = NULL;
+	PurpleContactInfo *info = NULL;
 
 	account = purple_account_new("test", "test");
 	contact = purple_contact_new(account, "id");
+	info = PURPLE_CONTACT_INFO(contact);
 
 	g_assert_true(purple_contact_get_account(contact) == account);
-	g_assert_cmpstr(purple_contact_get_id(contact), ==, "id");
+	g_assert_cmpstr(purple_contact_info_get_id(info), ==, "id");
 
 	g_clear_object(&contact);
 	g_clear_object(&account);
@@ -45,21 +47,9 @@
 	PurpleAccount *account = NULL;
 	PurpleAccount *account1 = NULL;
 	PurpleContact *contact = NULL;
-	PurpleContactPermission permission;
-	PurplePerson *person = NULL;
-	PurplePerson *person1 = NULL;
-	PurplePresence *presence1 = NULL;
-	PurpleTags *tags = NULL;
-	GdkPixbuf *avatar = NULL;
-	GdkPixbuf *avatar1 = NULL;
-	gchar *id = NULL;
-	gchar *username = NULL;
-	gchar *display_name = NULL;
-	gchar *alias = NULL;
+	char *id = NULL;
 
 	account = purple_account_new("test", "test");
-	avatar = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8, 1, 1);
-	person = purple_person_new();
 
 	/* Use g_object_new so we can test setting properties by name. All of them
 	 * call the setter methods, so by doing it this way we exercise more of the
@@ -69,280 +59,26 @@
 		PURPLE_TYPE_CONTACT,
 		"account", account,
 		"id", "id1",
-		"username", "username",
-		"display-name", "display-name",
-		"alias", "alias",
-		"avatar", avatar,
-		"person", person,
-		"permission", PURPLE_CONTACT_PERMISSION_ALLOW,
 		NULL);
 
 	/* Now use g_object_get to read all of the properties. */
 	g_object_get(contact,
 		"id", &id,
 		"account", &account1,
-		"username", &username,
-		"display-name", &display_name,
-		"alias", &alias,
-		"avatar", &avatar1,
-		"presence", &presence1,
-		"tags", &tags,
-		"person", &person1,
-		"permission", &permission,
 		NULL);
 
 	/* Compare all the things. */
 	g_assert_cmpstr(id, ==, "id1");
 	g_assert_true(account1 == account);
-	g_assert_cmpstr(username, ==, "username");
-	g_assert_cmpstr(display_name, ==, "display-name");
-	g_assert_cmpstr(alias, ==, "alias");
-	g_assert_true(avatar1 == avatar);
-	g_assert_nonnull(presence1);
-	g_assert_nonnull(tags);
-	g_assert_true(person1 == person);
-	g_assert_true(permission == PURPLE_CONTACT_PERMISSION_ALLOW);
 
 	/* Free/unref all the things. */
 	g_clear_pointer(&id, g_free);
 	g_clear_object(&account1);
-	g_clear_pointer(&username, g_free);
-	g_clear_pointer(&display_name, g_free);
-	g_clear_pointer(&alias, g_free);
-	g_clear_object(&avatar1);
-	g_clear_object(&presence1);
-	g_clear_object(&tags);
-	g_clear_object(&person);
-	g_clear_object(&person1);
-
-	g_clear_object(&avatar);
 	g_clear_object(&contact);
 	g_clear_object(&account);
 }
 
 /******************************************************************************
- * get_name_for_display tests
- *****************************************************************************/
-static void
-test_purple_contact_get_name_for_display_person_with_alias(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
-	PurplePerson *person = NULL;
-	const char *alias = NULL;
-
-	account = purple_account_new("test", "test");
-
-	person = purple_person_new();
-	purple_person_set_alias(person, "this is the alias");
-
-	contact = purple_contact_new(account, NULL);
-	purple_contact_set_person(contact, person);
-
-	alias = purple_contact_get_name_for_display(contact);
-	g_assert_cmpstr(alias, ==, "this is the alias");
-
-	g_clear_object(&account);
-	g_clear_object(&contact);
-	g_clear_object(&person);
-}
-
-static void
-test_purple_contact_get_name_for_display_contact_with_alias(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
-	PurplePerson *person = NULL;
-	const char *alias = NULL;
-
-	account = purple_account_new("test", "test");
-	person = purple_person_new();
-
-	contact = purple_contact_new(account, NULL);
-	purple_contact_set_person(contact, person);
-
-	purple_contact_set_alias(contact, "this is the alias");
-
-	alias = purple_contact_get_name_for_display(contact);
-	g_assert_cmpstr(alias, ==, "this is the alias");
-
-	g_clear_object(&account);
-	g_clear_object(&contact);
-	g_clear_object(&person);
-}
-
-static void
-test_purple_contact_get_name_for_display_contact_with_display_name(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
-	PurplePerson *person = NULL;
-	const char *alias = NULL;
-
-	account = purple_account_new("test", "test");
-	person = purple_person_new();
-
-	contact = purple_contact_new(account, NULL);
-	purple_contact_set_person(contact, person);
-
-	purple_contact_set_display_name(contact, "this is the display name");
-
-	alias = purple_contact_get_name_for_display(contact);
-	g_assert_cmpstr(alias, ==, "this is the display name");
-
-	g_clear_object(&account);
-	g_clear_object(&contact);
-	g_clear_object(&person);
-}
-
-static void
-test_purple_contact_get_name_for_display_username_fallback(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
-	PurplePerson *person = NULL;
-	const char *alias = NULL;
-
-	account = purple_account_new("test", "test");
-	person = purple_person_new();
-
-	contact = purple_contact_new(account, NULL);
-	purple_contact_set_username(contact, "username");
-	purple_contact_set_person(contact, person);
-
-	alias = purple_contact_get_name_for_display(contact);
-	g_assert_cmpstr(alias, ==, "username");
-
-	g_clear_object(&account);
-	g_clear_object(&contact);
-	g_clear_object(&person);
-}
-
-static void
-test_purple_contact_get_name_for_display_id_fallback(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
-	PurplePerson *person = NULL;
-	const char *alias = NULL;
-
-	account = purple_account_new("test", "test");
-	person = purple_person_new();
-
-	contact = purple_contact_new(account, "id");
-	purple_contact_set_person(contact, person);
-
-	alias = purple_contact_get_name_for_display(contact);
-	g_assert_cmpstr(alias, ==, "id");
-
-	g_clear_object(&account);
-	g_clear_object(&contact);
-	g_clear_object(&person);
-}
-
-/******************************************************************************
- * purple_contact_compare tests
- *****************************************************************************/
-static void
-test_purple_contact_compare_not_null__null(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
-
-	account = purple_account_new("test", "test");
-	contact = purple_contact_new(account, NULL);
-
-	g_assert_cmpint(purple_contact_compare(contact, NULL), <, 0);
-
-	g_clear_object(&account);
-	g_clear_object(&contact);
-}
-
-static void
-test_purple_contact_compare_null__not_null(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact = NULL;
-
-	account = purple_account_new("test", "test");
-	contact = purple_contact_new(account, NULL);
-
-	g_assert_cmpint(purple_contact_compare(NULL, contact), >, 0);
-
-	g_clear_object(&account);
-	g_clear_object(&contact);
-}
-
-static void
-test_purple_contact_compare_null__null(void) {
-	g_assert_cmpint(purple_contact_compare(NULL, NULL), ==, 0);
-}
-
-static void
-test_purple_contact_compare_person__no_person(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact_a = NULL;
-	PurpleContact *contact_b = NULL;
-	PurplePerson *person = NULL;
-
-	account = purple_account_new("test", "test");
-
-	contact_a = purple_contact_new(account, NULL);
-	person = purple_person_new();
-	purple_contact_set_person(contact_a, person);
-
-	contact_b = purple_contact_new(account, NULL);
-
-	g_assert_cmpint(purple_contact_compare(contact_a, contact_b), <, 0);
-
-	g_clear_object(&account);
-	g_clear_object(&contact_a);
-	g_clear_object(&contact_b);
-	g_clear_object(&person);
-}
-
-static void
-test_purple_contact_compare_no_person__person(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact_a = NULL;
-	PurpleContact *contact_b = NULL;
-	PurplePerson *person = NULL;
-
-	account = purple_account_new("test", "test");
-
-	contact_a = purple_contact_new(account, NULL);
-
-	contact_b = purple_contact_new(account, NULL);
-	person = purple_person_new();
-	purple_contact_set_person(contact_b, person);
-
-	g_assert_cmpint(purple_contact_compare(contact_a, contact_b), >, 0);
-
-	g_clear_object(&account);
-	g_clear_object(&contact_a);
-	g_clear_object(&contact_b);
-	g_clear_object(&person);
-}
-
-static void
-test_purple_contact_compare_name__name(void) {
-	PurpleAccount *account = NULL;
-	PurpleContact *contact_a = NULL;
-	PurpleContact *contact_b = NULL;
-
-	account = purple_account_new("test", "test");
-
-	contact_a = purple_contact_new(account, NULL);
-	purple_contact_set_username(contact_a, "aaa");
-
-	contact_b = purple_contact_new(account, NULL);
-	purple_contact_set_username(contact_b, "zzz");
-
-	g_assert_cmpint(purple_contact_compare(contact_a, contact_b), <, 0);
-	g_assert_cmpint(purple_contact_compare(contact_b, contact_a), >, 0);
-
-	purple_contact_set_username(contact_b, "aaa");
-	g_assert_cmpint(purple_contact_compare(contact_b, contact_a), ==, 0);
-
-	g_clear_object(&account);
-	g_clear_object(&contact_a);
-	g_clear_object(&contact_b);
-}
-
-/******************************************************************************
  * Main
  *****************************************************************************/
 gint
@@ -356,29 +92,5 @@
 	g_test_add_func("/contact/properties",
 	                test_purple_contact_properties);
 
-	g_test_add_func("/contact/get_name_for_display/person_with_alias",
-	                test_purple_contact_get_name_for_display_person_with_alias);
-	g_test_add_func("/contact/get_name_for_display/contact_with_alias",
-	                test_purple_contact_get_name_for_display_contact_with_alias);
-	g_test_add_func("/contact/get_name_for_display/contact_with_display_name",
-	                test_purple_contact_get_name_for_display_contact_with_display_name);
-	g_test_add_func("/contact/get_name_for_display/username_fallback",
-	                test_purple_contact_get_name_for_display_username_fallback);
-	g_test_add_func("/contact/get_name_for_display/id_fallback",
-	                test_purple_contact_get_name_for_display_id_fallback);
-
-	g_test_add_func("/contact/compare/not_null__null",
-	                test_purple_contact_compare_not_null__null);
-	g_test_add_func("/contact/compare/null__not_null",
-	                test_purple_contact_compare_null__not_null);
-	g_test_add_func("/contact/compare/null__null",
-	                test_purple_contact_compare_null__null);
-	g_test_add_func("/contact/compare/person__no_person",
-	                test_purple_contact_compare_person__no_person);
-	g_test_add_func("/contact/compare/no_person__person",
-	                test_purple_contact_compare_no_person__person);
-	g_test_add_func("/contact/compare/name__name",
-	                test_purple_contact_compare_name__name);
-
 	return g_test_run();
 }
